
// SLMediaInfoTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SLMediaInfoTest.h"
#include "SLMediaInfoTestDlg.h"
//#include "afxdialogex.h"
#include "PerfCounter.h"
//#include <atlmisc.h>
#include <algorithm>
#include <random>
#include <functional> // ref()


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSLMediaInfoTestDlg dialog



CSLMediaInfoTestDlg::CSLMediaInfoTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSLMediaInfoTestDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSLMediaInfoTestDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Text(pDX, IDC_EDIT_MEDIA, m_mediaFile);
    DDX_Control(pDX, IDC_COMBO_AUDIO_STREAM, m_comboAudioStreams);
    DDX_Control(pDX, IDC_COMBO_SATELLITE, m_comboSatellites);
    DDX_Control(pDX, IDC_LIST_FILES, m_listFiles);
    DDX_Control(pDX, IDC_LIST_ERRORS, m_listErrors);
    DDX_Check(pDX, IDC_WITH_SUBDIRS, m_withSubdirs);
    DDX_Check(pDX, IDC_FAST, m_fast);
    DDX_Check(pDX, IDC_FAST_FIND_FILE, m_fastFindFile);
    DDX_Control(pDX, IDC_SPIN_TIME, m_spinTime);
    DDX_Check(pDX, IDC_SHUFFLE, m_shuffle);
}

BEGIN_MESSAGE_MAP(CSLMediaInfoTestDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
    ON_BN_CLICKED(IDC_BROWSE, &CSLMediaInfoTestDlg::OnBnClickedBrowse)
    ON_WM_DESTROY()
    ON_BN_CLICKED(IDC_CHECK, &CSLMediaInfoTestDlg::OnBnClickedCheck)
    ON_BN_CLICKED(IDOK, &CSLMediaInfoTestDlg::OnBnClickedOk)
    ON_BN_CLICKED(IDCANCEL, &CSLMediaInfoTestDlg::OnBnClickedCancel)
    ON_BN_CLICKED(IDC_CHECK_DIR, &CSLMediaInfoTestDlg::OnBnClickedCheckDir)
	ON_WM_GETMINMAXINFO()
    ON_BN_CLICKED(IDC_CHECK_DIR_EX, &CSLMediaInfoTestDlg::OnBnClickedCheckDirEx)
    ON_BN_CLICKED(IDC_PICK_TIME, &CSLMediaInfoTestDlg::OnBnClickedPickTime)
    //ON_BN_CLICKED(IDC_SCAN_START, &CSLMediaInfoTestDlg::OnBnClickedScanStart)
    //ON_BN_CLICKED(IDC_SCAN_STOP, &CSLMediaInfoTestDlg::OnBnClickedScanStop)
    //ON_BN_CLICKED(IDC_SCAN_ADD, &CSLMediaInfoTestDlg::OnBnClickedScanAdd)
    //ON_BN_CLICKED(IDC_SCAN_REMOVE, &CSLMediaInfoTestDlg::OnBnClickedScanRemove)
    ON_BN_CLICKED(IDC_PICK_TIME_EX, &CSLMediaInfoTestDlg::OnBnClickedPickTimeEx)
END_MESSAGE_MAP()


// CSLMediaInfoTestDlg message handlers

BOOL CSLMediaInfoTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

    HRESULT hr = m_mediaInfoCreator.CreateInstance(__uuidof(SLMediaInfoCreator));
    if (FAILED(hr)) return FALSE;

    CWinApp* pApp = AfxGetApp();
    CString strSection = _T("MediaInfo");

    m_mediaFile = pApp->GetProfileString(strSection, _T("mediaFile"), _T(""));

    m_spinTime.SetBuddy(GetDlgItem(IDC_EDIT_TIME));
    m_spinTime.SetRange32(1, 10000);
    m_spinTime.SetPos32(pApp->GetProfileInt(strSection, _T("time"), 20));

    ISLMediaInfoConfiguratorPtr configurator = m_mediaInfoCreator;
    UpdateScanningState(configurator);

    UpdateData(FALSE);

	CRect rc;
	GetClientRect(rc);
	GetDynamicLayout()->SetMinSize(rc.Size());
	
	GetWindowRect(rc);
	m_minSize = rc.Size();

    //CString filter = m_mediaInfoCreator->GetFilter(SLMediaType_All).GetBSTR();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSLMediaInfoTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSLMediaInfoTestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSLMediaInfoTestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CSLMediaInfoTestDlg::OnBnClickedBrowse()
{
    ReenterLock reenter{ m_InAction };
    if (reenter)
        return;
    if (m_mediaInfoCreator == NULL) return;
    try
    {
        UpdateData();
        CString filter = m_mediaInfoCreator->GetFilter(SLMediaType_All).GetBSTR();
        filter += _T("All files (*.*)|*.*||");
        CFileDialog fileDlg(TRUE, NULL, m_mediaFile, OFN_FILEMUSTEXIST, filter, this);
        CPath path(m_mediaFile);
        path.RemoveFileSpec();
        fileDlg.m_ofn.lpstrInitialDir = path;
        if (fileDlg.DoModal() == IDOK)
        {
            m_mediaFile = fileDlg.GetPathName();

            CPerfCounter timer;
            timer.Start();

            try
            {
				MediaInfo  info = m_mediaInfoCreator->GetMediaInfo((_bstr_t)m_mediaFile);
                SetCheckTime(timer.Finish(), IDC_CHECK_TIME);
                UpdateMediaInfo(&info);

                //CoTaskMemFree(info);
            }
            catch (_com_error& e)
            {
                MessageBox(e.Description());
            }

        }
        UpdateData(FALSE);
    }
    catch (_com_error& err)
    {
        MessageBox(err.ErrorMessage());
    }
}


void CSLMediaInfoTestDlg::OnDestroy()
{
    if (!m_mediaFile.IsEmpty()) {
        CWinApp* pApp = AfxGetApp();
        CString strSection = _T("MediaInfo");

        pApp->WriteProfileString(strSection, _T("mediaFile"), m_mediaFile);
        pApp->WriteProfileInt(strSection, _T("time"), m_spinTime.GetPos32());
    }

    CDialog::OnDestroy();
}


void CSLMediaInfoTestDlg::OnBnClickedCheck()
{
    ReenterLock reenter{ m_InAction };
    if (reenter)
        return;
    UpdateData();
    {
        CPerfCounter timer;
        timer.Start();

        try {
            //MediaInfo info;
            //ZeroMemory(&info, sizeof(info));
            ISLMediaInfoPtr iMediaInfo = m_mediaInfoCreator->Create((_bstr_t)m_mediaFile);

            SetCheckTime(timer.Finish(), IDC_CHECK_TIME);

            //iMediaInfo->GetInfo(&info);
            UpdateMediaInfo(iMediaInfo);
        }
        catch (_com_error& e)
        {
            MessageBox(e.Description() + e.ErrorMessage());
        }

    }
    UpdateData(FALSE);
}

void CSLMediaInfoTestDlg::UpdateMediaInfo(MediaInfo* info)
{
    if (info->_srcVideoPresent) {
        CString str;
        //str.Format(_T("%s (mSec)"), CRPMTimeSpan(info->_srcDurationShots, info->_srcFrameRate).FormatSeconts(true));
        str.Format(_T("%.4f sec"), info->_durationSec);
        SetDlgItemText(IDC_EDIT_DURATION, str);

        str.Format(_T("%.4f (fr/sec)"), info->_srcFrameRate);
        SetDlgItemText(IDC_EDIT_FRAME_RATE, str);

        str.Format(_T("%d x %d"), info->_srcCX, info->_srcCY);
        SetDlgItemText(IDC_EDIT_SIZE, str);

        str = GetScreenAspectStr(info, true);
        SetDlgItemText(IDC_EDIT_SCREEN_ASPECT, str);

        long pixelAspectX = 1;
        long pixelAspectY = 1;
        CalcPixelAspect(info, &pixelAspectX, &pixelAspectY);
        str.Format(_T("%d : %d (%.4f)"), pixelAspectX, pixelAspectY, (float)pixelAspectX / (float)pixelAspectY);
        SetDlgItemText(IDC_EDIT_PIXEL_ASPECT, str);

        str = info->_srcAlphaPresent ? _T("Yes") : _T("No");
        SetDlgItemText(IDC_EDIT_ALPHA, str);

        str = _T("unk");
        if (info->_srcFOURCC != 0) {
            str.Format(_T("'%.4hs'"), &(info->_srcFOURCC));
        }

        SetDlgItemText(IDC_EDIT_FOURCC, str);

        switch (info->_srcFieldOrder) {
        case 0:
            str = _T("Lower field first"); //.LoadString(IDS_SHOW_LOWER_FIELD_FIRST);
            break;
        case -1:
            str = _T("Progressive");//.LoadString(IDS_SHOW_PROGRESSIVE_FIELD);
            break;
        case 1:
        default:
            str = _T("Upper field first"); //.LoadString(IDS_SHOW_UPPER_FIELD_FIRST);
            break;
        }
        SetDlgItemText(IDC_EDIT_FIELD_ORDER, str);

    }

    SetDlgItemInt(IDC_AUDIO_STREAMS_COUNT, info->_srcAudioPresent);
    SetDlgItemInt(IDC_AUDIO_SAMPLE_RATE, info->_srcAudioSampleRate);
    SetDlgItemInt(IDC_AUDIO_CHANNELS, info->_srcAudioChannels);

    m_comboAudioStreams.ResetContent();
    BOOL enable = info->_srcAudioPresent > 1;
    m_comboAudioStreams.EnableWindow(enable);

}

void CSLMediaInfoTestDlg::UpdateMediaInfo(ISLMediaInfo* iMediaInfo)
{
    ATLASSERT(iMediaInfo != NULL);
    if (iMediaInfo->VideoPresent) {
        CString str;
        //str.Format(_T("%s (mSec)"), CRPMTimeSpan(iMediaInfo->_srcDurationShots, iMediaInfo->_srcFrameRate).FormatSeconts(true));
        str.Format(_T("%.4f sec"), iMediaInfo->DurationSec);
        SetDlgItemText(IDC_EDIT_DURATION, str);

        str.Format(_T("%.4f (fr/sec)"), iMediaInfo->FrameRate);
        SetDlgItemText(IDC_EDIT_FRAME_RATE, str);

        str.Format(_T("%d x %d"), iMediaInfo->CX, iMediaInfo->CY);
        SetDlgItemText(IDC_EDIT_SIZE, str);

        long srcAX = iMediaInfo->AspectRatioX;
        long srcAY = iMediaInfo->AspectRatioY;
        long cx = iMediaInfo->CX;
        long cy = iMediaInfo->CY;
        str = GetScreenAspectStr(cx, cy, srcAX, srcAY, true);
        SetDlgItemText(IDC_EDIT_SCREEN_ASPECT, str);

        long pixelAspectX = 1;
        long pixelAspectY = 1;
        CalcPixelAspect(cx, cy, srcAX, srcAY, &pixelAspectX, &pixelAspectY);
        str.Format(_T("%d : %d (%.4f)"), pixelAspectX, pixelAspectY, (float)pixelAspectX / (float)pixelAspectY);
        SetDlgItemText(IDC_EDIT_PIXEL_ASPECT, str);

        str = iMediaInfo->AlphaPresent ? _T("Yes") : _T("No");
        SetDlgItemText(IDC_EDIT_ALPHA, str);

        str = _T("unk");
        long fourcc = iMediaInfo->FOURCC;
        if (fourcc != 0) {
            str.Format(_T("'%.4hs'"), &(fourcc));
        }

        SetDlgItemText(IDC_EDIT_FOURCC, str);

        switch (iMediaInfo->FieldOrder) {
        case 0:
            str = _T("Lower field first"); //.LoadString(IDS_SHOW_LOWER_FIELD_FIRST);
            break;
        case -1:
            str = _T("Progressive");//.LoadString(IDS_SHOW_PROGRESSIVE_FIELD);
            break;
        case 1:
        default:
            str = _T("Upper field first"); //.LoadString(IDS_SHOW_UPPER_FIELD_FIRST);
            break;
        }
        SetDlgItemText(IDC_EDIT_FIELD_ORDER, str);

    }

    SetDlgItemInt(IDC_AUDIO_STREAMS_COUNT, iMediaInfo->AudioPresent);
    SetDlgItemInt(IDC_AUDIO_SAMPLE_RATE, iMediaInfo->AudioSampleRate);
    SetDlgItemInt(IDC_AUDIO_CHANNELS, iMediaInfo->AudioChannels);

    int cnt = iMediaInfo->AudioPresent;
    m_comboAudioStreams.ResetContent();
    BOOL enable = cnt > 1;
    m_comboAudioStreams.EnableWindow(enable);

    if (cnt >= 1) {
        for (int i = 0; i < cnt; ++i) {
            //AudioStreamInfo audio{ 0 };
            //iMediaInfo->GetAudioStreamInfo(i, &audio);
			AudioStreamInfo audio = iMediaInfo->GetAudioStreamInfo(i);
			for (int c = 0; c < 4; ++c) if (audio._language[c] == 0) audio._language[c] = L'_';

            CString str;
            //str.Format(_T("%d - %ws"), audio._index + 1, (LPCTSTR)(CISO639LangCode::ToString(audio.language)));
            str.Format(_T("%d - %.4ws"), audio._index + 1, &(audio._language[0]));

            m_comboAudioStreams.AddString(str);
        }
        m_comboAudioStreams.SetCurSel(0);

        //SetDlgItemInt(IDC_EDIT_SAMPLE_RATE, iMediaInfo->_audioStreams[getCurrAudioStream()]._sampleRate);
        //SetDlgItemInt(IDC_EDIT_CHANNELS, iMediaInfo->_audioStreams[getCurrAudioStream()]._channels);
    }

    m_comboSatellites.ResetContent();
    cnt = iMediaInfo->GetSatellitesCount();
    enable = cnt > 0;
    m_comboSatellites.EnableWindow(enable);

    SetDlgItemInt(IDC_SATELLITE_COUNT, cnt);

    if (cnt > 0) {
        for (int i = 0; i < cnt; ++i) {
            ////ISLMediaInfoPtr iSatellite = iMediaInfo->GetSatellite(i);
            //AudioStreamInfo audio{ 0 };
            //CComBSTR name;
            //iMediaInfo->GetSatelliteInfo(i, &audio, &name);
            ////iSatellite->GetAudioStreamInfo(0, &audio);
			CComBSTR name;
			AudioStreamInfo audio = iMediaInfo->GetSatelliteInfo(i, &name);
			for (int c = 0; c < 4; ++c) if (audio._language[c] == 0) audio._language[c] = L'_';

			CPath path(name); 
            CString str;
            //str.Format(_T("%d - %ws"), audio._index + 1, (LPCTSTR)(CISO639LangCode::ToString(audio.language)));
            str.Format(_T("%.4ws - %s"), audio._language, ((LPCTSTR)path) + path.FindFileName());

            m_comboSatellites.AddString(str);
        }
        m_comboSatellites.SetCurSel(0);

        //SetDlgItemInt(IDC_EDIT_SAMPLE_RATE, iMediaInfo->_audioStreams[getCurrAudioStream()]._sampleRate);
        //SetDlgItemInt(IDC_EDIT_CHANNELS, iMediaInfo->_audioStreams[getCurrAudioStream()]._channels);
    }
}

void CSLMediaInfoTestDlg::CalcPixelAspect(MediaInfo* info, long* pixelAspectX, long* pixelAspectY)
{

    long srcAX = info->_srcAspectRatioX;
    long srcAY = info->_srcAspectRatioY;
    long cx = info->_srcCX;
    long cy = info->_srcCY;
    CalcPixelAspect(cx, cy, srcAX, srcAY, pixelAspectX, pixelAspectY);
}

void CSLMediaInfoTestDlg::CalcPixelAspect(long cx, long cy, long srcAX, long srcAY, long* pixelAspectX, long* pixelAspectY)
{
    ATLASSERT(pixelAspectX != NULL && pixelAspectY != NULL);
    *pixelAspectX = 1;
    *pixelAspectY = 1;
    if (srcAX == 0 || srcAY == 0) {
        return;
    }
    if (cx == 720 && (cy == 480 || cy == 486)) {
        if (srcAX == 4 && srcAY == 3) {
            *pixelAspectX = 8;
            *pixelAspectY = 9;
            return;
        }
        if (srcAX == 16 && srcAY == 9) {
            *pixelAspectX = 96;
            *pixelAspectY = 81;
            return;
        }
    }
    if (cx == 720 && (cy == 576/* || cy == 580*/)) {
        if (srcAX == 4 && srcAY == 3) {
            *pixelAspectX = 16;
            *pixelAspectY = 15;
            return;
        }
        if (srcAX == 16 && srcAY == 9) {
            *pixelAspectX = 64;
            *pixelAspectY = 45;
            return;
        }
    }
    *pixelAspectX = long(((double)srcAX / (double)srcAY) / ((double)cx / (double)cy) * cx);
    *pixelAspectY = cx;
    long nod = gcd(*pixelAspectX, *pixelAspectY);
    if (*pixelAspectX / nod < 200) {
        *pixelAspectX /= nod;
        *pixelAspectY /= nod;
    }
    //else    200, 
    //   -        :-)
}

void CSLMediaInfoTestDlg::CalcScreenAspect(MediaInfo* info, long* screenAspectX, long* screenAspectY)
{

    long srcAX = info->_srcAspectRatioX;
    long srcAY = info->_srcAspectRatioY;
    long cx = info->_srcCX;
    long cy = info->_srcCY;
    CalcScreenAspect(cx, cy, srcAX, srcAY, screenAspectX, screenAspectY);
}

void CSLMediaInfoTestDlg::CalcScreenAspect(long cx, long cy, long srcAX, long srcAY, long* screenAspectX, long* screenAspectY)
{
    double srcAspect = (double)cx / (double)cy;
    double aspectRatio = srcAX == 0 || srcAY == 0 ? srcAspect : (double)srcAX / (double)srcAY;

    //  
    *screenAspectX = (long)(cx * aspectRatio / srcAspect);
    *screenAspectY = cy;
    if (srcAX == 0 || srcAY == 0 || srcAX > 100) {
        long nod = gcd(*screenAspectX, *screenAspectY);
        if (*screenAspectX / nod < 100 || srcAX > 100) {
            *screenAspectX /= nod;
            *screenAspectY /= nod;
        }
        //else    100, 
        //   -        :-)
        //   
    }
}

CString CSLMediaInfoTestDlg::GetScreenAspectStr(MediaInfo* info, bool wide)
{
    long srcAX = info->_srcAspectRatioX;
    long srcAY = info->_srcAspectRatioY;
    long cx = info->_srcCX;
    long cy = info->_srcCY;
    return GetScreenAspectStr(cx, cy, srcAX, srcAY, wide);
}

CString CSLMediaInfoTestDlg::GetScreenAspectStr(long cx, long cy, long srcAX, long srcAY, bool wide)
{
    CString str;
    long screenAspectX = cx;
    long screenAspectY = cy;
    CalcScreenAspect(cx, cy, srcAX, srcAY, &screenAspectX, &screenAspectY);

    CString fmt = wide ? _T("%d : %d (%d : %d)") : _T("%d:%d (%d:%d)");
    str.Format(fmt, srcAX, srcAY, screenAspectX, screenAspectY);
    return str;
}

void CSLMediaInfoTestDlg::SetCheckTime(double time, int nID)
{
    CString str; str.Format(_T("%.5f"), time);
    SetDlgItemText(nID, str);
}

void CSLMediaInfoTestDlg::OnBnClickedOk()
{
    ReenterLock reenter{ m_InAction };
    if (reenter)
        return;
    // TODO: Add your control notification handler code here
    CDialog::OnOK();
}


void CSLMediaInfoTestDlg::OnBnClickedCancel()
{
    ReenterLock reenter{ m_InAction };
    if (reenter)
        return;
    // TODO: Add your control notification handler code here
    CDialog::OnCancel();
}

//DEFINE_AUTOMATION_TYPE_FUNCTION(MediaInfoEx, MediaInfoEx, VT_RECORD);

void CSLMediaInfoTestDlg::OnBnClickedCheckDirEx()
{
    ReenterLock reenter{ m_InAction };
    if (reenter)
        return;
    UpdateData();
    {

        HCURSOR hOld = SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
        try {
            m_listFiles.ResetContent();
            m_listErrors.ResetContent();
            SetDlgItemText(IDC_MEDIA_COUNT, _T(""));

            ISLMediaInfoCreator2Ptr creator2 = m_mediaInfoCreator;
            if (creator2 == nullptr) {
                MessageBox(_T("ISLMediaInfoCreator2 problem"));
                return;
            }
            CPath path(m_mediaFile);
            path.RemoveFileSpec();

            CPerfCounter timerAll;
            timerAll.Start();

            CPerfCounter timerQuery;
            timerQuery.Start();

            CComSafeArray<MediaInfoEx, VT_RECORD> mediaFiles =  creator2->GetMediaInfoCollection(SLMediaType::SLMediaType_All, (LPCWSTR)path, m_withSubdirs != FALSE, m_fast != FALSE);

            SetCheckTime(timerQuery.Finish(), IDC_CHECK_QUERY);

            size_t cnt = mediaFiles.GetCount();
            for (LONG i = 0; i < (LONG)mediaFiles.GetCount(); ++i)
            {
                try {
                    m_listFiles.AddString(ToString(mediaFiles[i]).c_str());

                    SetDlgItemText(IDC_MEDIA_COUNT, (std::wostringstream() << i + 1 << "/" << cnt).str().c_str());
                }
                catch (_com_error& e)
                {
                    CString err; err.Format(_T("'%s' %s"), mediaFiles[i], (LPCTSTR)e.Description());
                    m_listErrors.AddString(err);
                }
            }
            SetCheckTime(timerAll.Finish(), IDC_CHECK_TIME);
        }
        catch (const _com_error& e)
        {
            MessageBox(e.Description()/* + e.ErrorMessage()*/);
        }

        SetCursor(hOld);
    }
    UpdateData(FALSE);
}

std::vector<MediaInfoEx> CSLMediaInfoTestDlg::RandomizeMediaInfo(const CComSafeArray<MediaInfoEx, VT_RECORD>& mediaFiles)
{
    std::vector<MediaInfoEx> mediaInfos{ mediaFiles.GetCount() };
    for (LONG i = 0; i < (LONG)mediaFiles.GetCount(); ++i)
    {
        mediaInfos[i] = mediaFiles[i];
    }
    RandomizeMediaFiles(mediaInfos);
    return mediaInfos;
}


void CSLMediaInfoTestDlg::OnBnClickedPickTimeEx()
{
    ReenterLock reenter{ m_InAction };
    if (reenter)
        return;
    UpdateData();
    HCURSOR hOld = SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
    try {
        m_listFiles.ResetContent();
        m_listErrors.ResetContent();
        SetDlgItemText(IDC_MEDIA_COUNT, _T(""));

        ISLMediaInfoCreator2Ptr creator2 = m_mediaInfoCreator;
        if (creator2 == nullptr) {
            MessageBox(_T("ISLMediaInfoCreator2 problem"));
            return;
        }
        CPath path(m_mediaFile);
        path.RemoveFileSpec();

        CPerfCounter timerAll;
        timerAll.Start();

        CPerfCounter timerQuery;
        timerQuery.Start();

        CComSafeArray<MediaInfoEx, VT_RECORD> mediaFiles = creator2->GetMediaInfoCollection(SLMediaType::SLMediaType_All, (LPCWSTR)path, m_withSubdirs != FALSE, m_fast != FALSE);
        auto mediaInfos = RandomizeMediaInfo(mediaFiles);

        SetCheckTime(timerQuery.Finish(), IDC_CHECK_QUERY);

        double pickedTime = 0;
        double pickTime = m_spinTime.GetPos32() * 60.0;
        const double errTime = 1.5;
        size_t i{};
        size_t acceptedCnt{};
        for (const auto& iMediaInfo : mediaInfos)
        {
            if (pickedTime <= pickTime - errTime) {
                CPath path((LPCWSTR)iMediaInfo._name);
                if (pickedTime + iMediaInfo._durationSec <= pickTime + errTime) {
                    pickedTime += iMediaInfo._durationSec;
                    m_listFiles.AddString(ToString(iMediaInfo).c_str());
                    acceptedCnt++;
                }
                else {
                    m_listErrors.AddString(ToString(iMediaInfo).c_str());
                }
            }
            if (pickedTime >= pickTime - errTime)
                break;
            SetDlgItemText(IDC_MEDIA_COUNT, (std::wostringstream() << acceptedCnt << "/" << ++i << "/" << mediaInfos.size()).str().c_str());
        }
        SetCheckTime(timerAll.Finish(), IDC_CHECK_TIME);
        SetDlgItemText(IDC_PICKED_TIME, toSMPTEmSecString(std::chrono::duration<double>(pickedTime)));
    }
    catch (_com_error& e)
    {
        MessageBox(e.Description()/* + e.ErrorMessage()*/);
    }

    SetCursor(hOld);
    UpdateData(FALSE);
}

void CSLMediaInfoTestDlg::YieldMessage()
{
    MSG msg{};
    while (PeekMessage(&msg, m_hWnd, 0, 0, PM_REMOVE)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
}

std::vector<CString> CSLMediaInfoTestDlg::GetFiles()
{
    CPath path(m_mediaFile);
    path.RemoveFileSpec();
    std::vector<CString> mediaFiles;
    if (m_fastFindFile) {
        CString filter = m_mediaInfoCreator->GetFilter(SLMediaType_All).GetBSTR();
        auto extensions = GetExtFromFilter(filter);
        mediaFiles = FindMediaFiles(path, extensions, m_withSubdirs != FALSE);
    }
    else {
        mediaFiles = FindMediaFiles(path, m_withSubdirs != FALSE);
    }
    if (m_shuffle) {
        RandomizeMediaFiles(mediaFiles);
    }
    return mediaFiles;
}

void CSLMediaInfoTestDlg::OnBnClickedPickTime()
{
    ReenterLock reenter{ m_InAction };
    if (reenter)
        return;
    UpdateData();
    {
        HCURSOR hOld = SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
        try {
            m_listFiles.ResetContent();
            m_listErrors.ResetContent();
            SetDlgItemText(IDC_MEDIA_COUNT, _T(""));
            SetDlgItemText(IDC_CHECK_MIN, _T(""));
            SetDlgItemText(IDC_CHECK_MAX, _T(""));
            SetDlgItemText(IDC_CHECK_AVER, _T(""));
            SetDlgItemText(IDC_CHECK_QUERY, _T(""));
            SetDlgItemText(IDC_CHECK_TIME, _T(""));
            SetDlgItemText(IDC_PICKED_TIME, _T(""));
            m_mediaInfoCreator->GetFilter(SLMediaType_All).GetBSTR();

            double minCheck = (double)MAXLONG64;
            double maxCheck = (double)MINLONG64;
            double average = 0;
            CPerfCounter timerAll;
            timerAll.Start();

            CPerfCounter timerFindFiles;
            timerFindFiles.Start();

            std::vector<CString> mediaFiles = GetFiles();

            SetCheckTime(timerFindFiles.Finish(), IDC_CHECK_FIND_FILES);

            double pickedTime = 0;
            double pickTime = m_spinTime.GetPos32() * 60.0;
            const double errTime = 1.5;
            size_t i{};
            size_t acceptedCnt{};
            for (const auto& file : mediaFiles)
            {
                try {
                    CPerfCounter timer;
                    timer.Start();
                    auto iMediaInfo = m_mediaInfoCreator->GetMediaInfo((_bstr_t)file);

                    double time = timer.Finish();
                    minCheck = min(time, minCheck);
                    maxCheck = max(time, maxCheck);
                    average += time;

                    if (pickedTime <= pickTime - errTime) {
                        CPath path(file);
                        if (pickedTime + iMediaInfo._durationSec <= pickTime + errTime) {
                            pickedTime += iMediaInfo._durationSec;
                            m_listFiles.AddString(ToString(iMediaInfo, (LPCTSTR)path + path.FindFileName(), time).c_str());
                            acceptedCnt++;
                        }
                        else {
                            m_listErrors.AddString(ToString(iMediaInfo, (LPCTSTR)path + path.FindFileName(), time).c_str());
                        }
                    }
                    if (pickedTime >= pickTime - errTime)
                        break;

                    SetDlgItemText(IDC_MEDIA_COUNT, (std::wostringstream() << acceptedCnt << "/" << ++i << "/" << mediaFiles.size()).str().c_str());
                    SetCheckTime(minCheck, IDC_CHECK_MIN);
                    SetCheckTime(maxCheck, IDC_CHECK_MAX);
                    SetCheckTime(average / i, IDC_CHECK_AVER);
                    SetCheckTime(average, IDC_CHECK_QUERY);
                    SetCheckTime(timerAll.FromStart(), IDC_CHECK_TIME);
                    SetDlgItemText(IDC_PICKED_TIME, toSMPTEmSecString(std::chrono::duration<double>(pickedTime)));
                    YieldMessage();
                }
                catch (_com_error& e)
                {
                    CString err; err.Format(_T("'%s' %s"), (LPCTSTR)file, (LPCTSTR)e.Description());
                    m_listErrors.AddString(err);
                    //MessageBox(err);
                }
            }

            SetCheckTime(minCheck, IDC_CHECK_MIN);
            SetCheckTime(maxCheck, IDC_CHECK_MAX);
            SetCheckTime(average / i, IDC_CHECK_AVER);
            SetCheckTime(average, IDC_CHECK_QUERY);
            SetCheckTime(timerAll.Finish(), IDC_CHECK_TIME);
            SetDlgItemText(IDC_PICKED_TIME, toSMPTEmSecString(std::chrono::duration<double>(pickedTime)));
        }
        catch (_com_error& e)
        {
            MessageBox(e.Description()/* + e.ErrorMessage()*/);
        }

        SetCursor(hOld);
    }
    UpdateData(FALSE);
}

void CSLMediaInfoTestDlg::OnBnClickedCheckDir()
{
    ReenterLock reenter{ m_InAction };
    if (reenter)
        return;
    UpdateData();
    {
        HCURSOR hOld = SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
        try {
            m_listFiles.ResetContent();
            m_listErrors.ResetContent();
            SetDlgItemText(IDC_MEDIA_COUNT, _T(""));
            SetDlgItemText(IDC_CHECK_MIN, _T(""));
            SetDlgItemText(IDC_CHECK_MAX, _T(""));
            SetDlgItemText(IDC_CHECK_AVER, _T(""));
            SetDlgItemText(IDC_CHECK_QUERY, _T(""));
            SetDlgItemText(IDC_CHECK_TIME, _T(""));

            CPath path(m_mediaFile);
            path.RemoveFileSpec();

            m_mediaInfoCreator->GetFilter(SLMediaType_All).GetBSTR();

            double minCheck = (double)MAXLONG64;
            double maxCheck = (double)MINLONG64;
            double average = 0;
            CPerfCounter timerAll;
            timerAll.Start();

            CPerfCounter timerFindFiles;
            timerFindFiles.Start();

            std::vector<CString> mediaFiles;
            if (m_fastFindFile) {
                CString filter = m_mediaInfoCreator->GetFilter(SLMediaType_All).GetBSTR();
                auto extensions = GetExtFromFilter(filter);
                mediaFiles = FindMediaFiles(path, extensions, m_withSubdirs != FALSE);
            }
            else {
                mediaFiles = FindMediaFiles(path, m_withSubdirs != FALSE);
            }
            if (m_shuffle) {
                RandomizeMediaFiles(mediaFiles);
            }

            SetCheckTime(timerFindFiles.Finish(), IDC_CHECK_FIND_FILES);
            //m_listFiles.LockWindowUpdate();
            size_t cnt = mediaFiles.size();
            size_t i = 0;
            for (const auto& file : mediaFiles)
            {
                try {
                    CPerfCounter timer;
                    timer.Start();
                    ISLMediaInfoPtr iMediaInfo = m_mediaInfoCreator->Create((_bstr_t)file);

                    double time = timer.Finish();
                    minCheck = min(time, minCheck);
                    maxCheck = max(time, maxCheck);
                    average += time;

                    CPath path(iMediaInfo->Name);
                    m_listFiles.AddString(ToString(iMediaInfo->GetInfo(), (LPCTSTR)path + path.FindFileName(), time).c_str());

                    SetDlgItemText(IDC_MEDIA_COUNT, (std::wostringstream() << ++i << "/" << cnt).str().c_str());
                    SetCheckTime(minCheck, IDC_CHECK_MIN);
                    SetCheckTime(maxCheck, IDC_CHECK_MAX);
                    SetCheckTime(average / i, IDC_CHECK_AVER);
                    SetCheckTime(average, IDC_CHECK_QUERY);
                    SetCheckTime(timerAll.FromStart(), IDC_CHECK_TIME);
                    YieldMessage();
                }
                catch (_com_error& e)
                {
                    CString err; err.Format(_T("'%s' %s"), (LPCTSTR)file, (LPCTSTR)e.Description());
                    m_listErrors.AddString(err);
                    //MessageBox(err);
                }
            }

            //average /= mediaFiles.size();

            SetCheckTime(minCheck, IDC_CHECK_MIN);
            SetCheckTime(maxCheck, IDC_CHECK_MAX);
            SetCheckTime(average / cnt, IDC_CHECK_AVER);
            SetCheckTime(average, IDC_CHECK_QUERY);
            SetCheckTime(timerAll.Finish(), IDC_CHECK_TIME);
        }
        catch (_com_error& e)
        {
            MessageBox(e.Description()/* + e.ErrorMessage()*/);
        }

        SetCursor(hOld);
    }
    UpdateData(FALSE);
}

void CSLMediaInfoTestDlg::FindMediaFiles(CPath path, CSimpleArray<CString> &extArr, CAtlArray<CString> &mediaFiles, bool withSubdirs)
{
    CAtlArray<CPath> subdirs;
    CFileFind finder;
    BOOL bWorking = finder.FindFile(path + _T("\\*.*"));
    while (bWorking)
    {
        bWorking = finder.FindNextFile();
        if (finder.MatchesMask(FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM | FILE_ATTRIBUTE_REPARSE_POINT | FILE_ATTRIBUTE_OFFLINE)) 
            continue;
        if (!finder.IsDirectory()) {
            CPath fileName(finder.GetFilePath());
            CString strFileExt = fileName.GetExtension().MakeLower();
            if (extArr.Find(strFileExt) >= 0)
            {
                mediaFiles.Add(fileName);
            }
        }
        else {
            if (!finder.IsDots()) {
                subdirs.Add(CPath(finder.GetFilePath()));
            }
        }
    }
    finder.Close();

    if (withSubdirs) {
        for (size_t i = 0; i < subdirs.GetCount(); ++i) {
            FindMediaFiles(subdirs[i], extArr, mediaFiles, withSubdirs);
        }
    }
}

void CSLMediaInfoTestDlg::GetExtFromFilter(const CString& filter, CSimpleArray<CString>& extArray)
{
    //    " 1|*.ex1;*.ex2| 2|*.ex3|"
    //       '|', 
    //   ( )
    extArray.RemoveAll();
    int curPos = 0;
    int cnt = 0;

    while (curPos != -1)
    {
        CString simpleFilter = filter.Tokenize(_T("|"), curPos);
        if (((cnt++) & 0x1) == 0) continue;  //  
        simpleFilter.Trim();
        if (simpleFilter.IsEmpty()) continue; //    ???
        //     ';' 
        int extPos = 0;
        while (extPos != -1) {
            CString ext = simpleFilter.Tokenize(_T(";"), extPos);
            ext.Trim();
            if (!ext.IsEmpty()) {
                //      
                ext.Trim(_T('*'));
                ext.MakeLower();
                if (extArray.Find(ext) < 0)
                    extArray.Add(ext);
            }
        }
    }
}

std::vector<CString> CSLMediaInfoTestDlg::FindMediaFiles(CPath path, const std::set<CString>& extensions, bool withSubdirs)
{
    using namespace std;
    vector<CString> mediaFiles;
    vector<CString> subdirs;
    CFileFind finder;
    BOOL bWorking = finder.FindFile(path + _T("\\*.*"));
    while (bWorking)
    {
        bWorking = finder.FindNextFile();
        if (finder.MatchesMask(FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM | FILE_ATTRIBUTE_REPARSE_POINT | FILE_ATTRIBUTE_OFFLINE))
            continue;
        if (!finder.IsDirectory()) {
            CPath fileName(finder.GetFilePath());
            CString strFileExt = fileName.GetExtension().MakeLower();
            //if (find(extensions.begin(), extensions.end(), strFileExt) != extensions.end()) {
            //    mediaFiles.push_back(fileName);
            //}
            if (extensions.count(strFileExt) != 0) {
                mediaFiles.push_back(fileName);
            }
        }
        else {
            if (!finder.IsDots()) {
                subdirs.push_back(CPath(finder.GetFilePath()));
            }
        }
    }
    finder.Close();

    if (withSubdirs) {
        for (size_t i = 0; i < subdirs.size(); ++i) {
            auto subFiles = FindMediaFiles(CPath(subdirs[i]), extensions, withSubdirs);
            mediaFiles.insert(mediaFiles.end(), subFiles.begin(), subFiles.end());
        }
    }
    return mediaFiles;
}

std::set<CString> CSLMediaInfoTestDlg::GetExtFromFilter(const CString& filter)
{
    //    " 1|*.ex1;*.ex2| 2|*.ex3|"
    //       '|', 
    //   ( )
    std::set<CString> extensions;
    int curPos = 0;
    int cnt = 0;

    while (curPos != -1)
    {
        CString simpleFilter = filter.Tokenize(_T("|"), curPos);
        if (((cnt++) & 0x1) == 0) continue;  //  
        simpleFilter.Trim();
        if (simpleFilter.IsEmpty()) continue; //    ???
        //     ';' 
        int extPos = 0;
        while (extPos != -1) {
            CString ext = simpleFilter.Tokenize(_T(";"), extPos);
            ext.Trim();
            if (!ext.IsEmpty()) {
                //      
                ext.Trim(_T('*'));
                ext.MakeLower();
                //if (find(extensions.begin(), extensions.end(), ext) == extensions.end())
                //    extensions.push_back(ext);
                if (extensions.count(ext) == 0)
                    extensions.insert(ext);
            }
        }
    }
    return extensions;
}

std::vector<CString> CSLMediaInfoTestDlg::FindMediaFiles(CPath path, bool withSubdirs)
{
    using namespace std;
    vector<CString> mediaFiles;
    vector<CString> subdirs;
    CFileFind finder;
    BOOL bWorking = finder.FindFile(path + _T("\\*.*"));
    while (bWorking)
    {
        bWorking = finder.FindNextFile();
        if (finder.MatchesMask(FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM | FILE_ATTRIBUTE_REPARSE_POINT | FILE_ATTRIBUTE_OFFLINE))
            continue;
        if (!finder.IsDirectory()) {
            CComBSTR fileName = finder.GetFilePath();
            SLMediaType type = SLMediaType::SLMediaType_Unknown;
            if (m_mediaInfoCreator->raw_GetMediaType(fileName, &type) == S_OK && type != SLMediaType::SLMediaType_Unknown) {
                mediaFiles.push_back((LPCWSTR)fileName);
            }
            //try {
            //    if (m_mediaInfoCreator->GetMediaType((LPCTSTR)fileName) != SLMediaType::SLMediaType_Unknown) {
            //        mediaFiles.push_back(fileName);
            //    }
            //}
            //catch (_com_error&) {}
        }
        else {
            if (!finder.IsDots()) {
                subdirs.push_back(CPath(finder.GetFilePath()));
            }
        }
    }
    finder.Close();

    if (withSubdirs) {
        for (size_t i = 0; i < subdirs.size(); ++i) {
            auto subFiles = FindMediaFiles(CPath(subdirs[i]), withSubdirs);
            mediaFiles.insert(mediaFiles.end(), subFiles.begin(), subFiles.end());
        }
    }
    return mediaFiles;
}

template <class T>
void CSLMediaInfoTestDlg::RandomizeMediaFiles(std::vector<T>& mediaFiles)
{
    using namespace std;

    random_device rd;
    mt19937_64 engine1(rd());
    shuffle(mediaFiles.begin(), mediaFiles.end(), engine1);
}

void CSLMediaInfoTestDlg::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
	// TODO: Add your message handler code here and/or call default

	CDialog::OnGetMinMaxInfo(lpMMI);
	if (m_minSize == CSize(0)) {
		m_minSize = lpMMI->ptMinTrackSize;
	}
	else {
		//CSize minSize = GetDynamicLayout()->GetMinSize();
		lpMMI->ptMinTrackSize = CPoint(m_minSize);
	}
}


void CSLMediaInfoTestDlg::OnBnClickedScanStart()
{
    ReenterLock reenter{ m_InAction };
    if (reenter)
        return;
    try {

        ISLMediaInfoConfiguratorPtr configurator = m_mediaInfoCreator;
        if (configurator != nullptr) {
            try {
                configurator->Start();
                configurator->RunAtStart = TRUE;
                UpdateScanningState(configurator);
            }
            catch (_com_error& e) {
                //MessageBox(e.Description()/* + e.ErrorMessage()*/);
                m_listErrors.AddString(e.Description());
            }
        }
    }
    catch (_com_error& e)
    {
        MessageBox(e.Description()/* + e.ErrorMessage()*/);
    }

    //SetCursor(hOld);
    //UpdateData(FALSE);
}


void CSLMediaInfoTestDlg::OnBnClickedScanStop()
{
    ReenterLock reenter{ m_InAction };
    if (reenter)
        return;
    try {
        ISLMediaInfoConfiguratorPtr configurator = m_mediaInfoCreator;
        if (configurator != nullptr) {
            try {
                configurator->Stop();
                configurator->RunAtStart = FALSE;
                UpdateScanningState(configurator);
            }
            catch (_com_error& e) {
                //MessageBox(e.Description()/* + e.ErrorMessage()*/);
                m_listErrors.AddString(e.Description());
            }
        }
    }
    catch (_com_error& e)
    {
        MessageBox(e.Description()/* + e.ErrorMessage()*/);
    }
}


void CSLMediaInfoTestDlg::OnBnClickedScanAdd()
{
    ReenterLock reenter{ m_InAction };
    if (reenter)
        return;
    UpdateData();
    //HCURSOR hOld = SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
    try {
        //m_listFiles.ResetContent();
        m_listErrors.ResetContent();
        //SetDlgItemText(IDC_MEDIA_COUNT, _T(""));

        CPath path(m_mediaFile);
        path.RemoveFileSpec();

        ISLMediaInfoConfiguratorPtr configurator = m_mediaInfoCreator;
        if (configurator != nullptr) {
            try {
                configurator->AddPath((LPCWSTR)path, m_withSubdirs);
                UpdateScanningState(configurator);
            }
            catch (_com_error& e) {
                //MessageBox(e.Description()/* + e.ErrorMessage()*/);
                m_listErrors.AddString(e.Description());
            }
        }
    }
    catch (_com_error& e)
    {
        MessageBox(e.Description()/* + e.ErrorMessage()*/);
    }

    //SetCursor(hOld);
    //UpdateData(FALSE);
}


void CSLMediaInfoTestDlg::OnBnClickedScanRemove()
{
    ReenterLock reenter{ m_InAction };
    if (reenter)
        return;
    UpdateData();
    try {
        //m_listFiles.ResetContent();
        m_listErrors.ResetContent();
        //SetDlgItemText(IDC_MEDIA_COUNT, _T(""));

        CPath path(m_mediaFile);
        path.RemoveFileSpec();

        ISLMediaInfoConfiguratorPtr configurator = m_mediaInfoCreator;
        if (configurator != nullptr) {
            try {
                configurator->RemovePath((LPCWSTR)path, m_withSubdirs);
                UpdateScanningState(configurator);
            }
            catch (_com_error& e) {
                //MessageBox(e.Description()/* + e.ErrorMessage()*/);
                m_listErrors.AddString(e.Description());
            }
        }
    }
    catch (_com_error& e)
    {
        MessageBox(e.Description()/* + e.ErrorMessage()*/);
    }

    //SetCursor(hOld);
    //UpdateData(FALSE);
}

